#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

long caseNo = 0;
struct Var{
	long code;
	char name[20];
	long len;
	long num;
	char let[5][5];
};
long pos = 0;
const Var var[7] = {{0, "int", 1, 1, "d"},
					{1, "char", 1, 1, "c"},
					{2, "string", 1, 1, "s"},
					{3, "single", 1, 5, "f", "e", "g", "E", "G"},
					{4, "longint", 2, 1, "ld"},
					{5, "double", 2, 5, "lf", "le", "lg", "lE", "lG"},
					{6, "extended", 2, 5, "Lf", "Le", "Lg", "LE", "LG"}};

bool finish = false;
const long MAX = 250;
char st[MAX];
long mas[MAX];
long N;

void Down(char * s){
	for (long i = 0; i < strlen(s); i++)
		s[i] = tolower(s[i]);
}


void Input(){
	memset(mas, 0, sizeof mas);
	cin >> N;
	while(cin.peek() == '\n')
		cin.ignore();
	long l = 0;
	while(cin.peek() != '\n'){
		st[l++] = cin.get();
	}
	char s[MAX];

	for (long i = 0; i < N - 1; i++){
		cin >> s;
		Down(s);
		for (long j = 0; j < 7; j++)
			if (!strcmp(s, var[j].name))
				mas[i] = var[j].code;
	}
}

void Solve()
{
	long k = 0;
	long len = strlen(st);
	for (long i = 0; i < len;){
		if (k >= N){
			cout << "ERROR 2" << endl;
			assert(0);
			return;
		}
		if (st[i] == '\\'){
			i +=2;
			continue;
		}
		if (st[i] != '%'){
			i++;
			continue;
		}
		if (st[i] == '%' && st[i + 1] == '%'){
			i += 2;
			continue;
		}
		if (st[i] == '%'){
			long j;
			for (j = i; !isalpha(st[j]); j++)
				if (st[j] == '*'){
					if (mas[k]){
						cout << "ERROR 1" << endl;
						return;
					} else
						k++;
				}
			i = j;
			char s0[MAX];
			if (var[mas[k]].len  == 1){
				s0[0] = st[i];
				s0[1] = 0;
				i++;
			} else{
				s0[0] = st[i];
				s0[1] = st[i + 1];
				s0[2] = 0;
				i += 2;
			}
			bool OK = false;
			for (long l = 0; l < var[mas[k]].num; l++){
				if (!strcmp(s0, var[mas[k]].let[l]))
					OK = true;
			}
			if (OK){
				k++;
				continue;
			}
			if (i >= len){
				cout << "ERROR 2" << endl;
				return;
			}
			cout << "ERROR 1" << endl;
			return;
		}
	}
	if (k >= N){
		cout << "ERROR 2" << endl;
		return;
	}

	if (k < N - 1){
		cout << "ERROR 3" << endl;
		return;
	}
	cout << "OK" << endl;
}

int main()
{
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
	cout = os;
	Input();
	Solve();
	return 0;
}