#include <fstream.h>
#include <math.h>
const double e = 1e-8;
struct pt
{
  long double x, y;
};
struct line
{
  long double a, b, c;
};
long double min(long double a, long double b)
{
  return a < b ? a : b;
}
long double max(long double a, long double b)
{
  return a > b ? a : b;
}
int inter(pt a, pt b, pt c, pt d)
{
  pt p;
  long double d0;
  line l1, l2;
  l1.a = b.y - a.y;
  l1.b = - (b.x - a.x);
  l1.c = - (l1.a * b.x + l1.b * b.y);
  l2.a = d.y - c.y;
  l2.b = - (d.x - c.x);
  l2.c = - (l2.a * c.x + l2.b * c.y);
  d0 = l1.a * l2.b - l1.b * l2.a;
  if (fabs(d0) < e)
  {
    return 0;
  }
  else
  {
    p.x = (l1.b * l2.c - l1.c * l2.b) / d0;
    p.y = (l1.c * l2.a - l1.a * l2.c) / d0;
    return min(a.x, b.x) <= p.x && p.x <= max(a.x, b.x) && min(a.y, b.y) <= p.y && p.y <= max(a.y, b.y) &&
	min(c.x, d.x) <= p.x && p.x <= max(c.x, d.x) && min(c.y, d.y) <= p.y && p.y <= max(c.y, d.y);
  }
}
main()
{
  long double s, s1, t, sp, sa, sa0;
  pt p, a, b, c, h, a0;
  line l;
  ifstream is("input.txt");
  ofstream os("output.txt");
  cin = is;
  cout = os;
  cin >> p.x >> p.y;
  a.x = 0;
  a.y = 0;
  b.x = 10; b.y = 0;
  c.x = 10; c.y = 10;
  s1 = 25;
  s = 0;
  sp = 0;
  a0 = a;
  do
  {
    h.x = (a.x + c.x) / 2;
    h.y = (a.y + c.y) / 2;
    l.a = h.y - b.y;
    l.b = - (h.x - b.x);
    l.c = - (l.a * b.x + l.b * b.y);
    t = l.a * p.x + l.b * p.y + l.c;
    sa = l.a * a.x + l.b * a.y + l.c;
    sa0 = l.a * a0.x + l.b * a0.y + l.c;
    if (t * sa0 <= 0 && inter(a0, p, b, h))
    {
      s += s1;
    }
    if (t * sa > 0)
    {
      c = b;
      b = h;
    }
    else
    {
      a = b;
      b = h;
    }
    s1 /= 2;
  }
  while (t != 0.0L);
  cout.precision(3);
  cout.setf(ios::fixed, ios::floatfield);
  cout.setf(ios::showpoint);
  cout << s << endl;
  return 0;
}