#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

typedef unsigned long ulong;
typedef unsigned int uint;

#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

char S[252];
int L;
int C[256];
ulong R, b, e;

FILE *f;

int isprep(char c) {
	return (c<'A'||c>'Z');
}

void clear() {
	for (int i=0; i<256; i++) {
		if (!strchr(S, i)) C[i] = 0;
	}
}

char space() {
	char c;
	do {
		c = fgetc(f);
		if (feof(f)) break;
	} while (isprep(c));
	return c;
}

int back(char c) {
	fseek(f, b, 0);
	char ch;
	do {
		ch = fgetc(f);
		if ( !isprep(ch) ) C[ch]++;
	} while (ch != c);
	b = ftell(f);
	clear();
//	if (!strchr(S, ch)) b++;
	fseek(f, e, 0);
	return 0;
}

int check() {
	for (int i=0; i<256; i++) {
		if (C[i]<0) {
			back(i);
			return check();
		}
	}
	for (i=0; i<256; i++) {
		if (C[i]>0) break;
	}
	if (i>=256) {
		R++;
		return 1;
	}
	return 0;
}

int main() {
/*	FILE *fi = fopen("input.txt", "r");
	fclose(fi);

	fscanf(fi, "%s", &N);
	FILE *fo = fopen("output.txt", "w");
	fprintf(fo, "%ld", R);
	fclose(fo);*/
	f = fopen("input.txt", "r");
	char c;
	L = 0;
	do {
		c = fgetc(f);
		if (!isprep(c)) S[L++] = c;
		if (c=='\n'||feof(f)) break;
	} while (1);
	S[L] = 0;
	for (int i=0; i<L; i++) {
		C[S[i]]++;
	}
	c = space();
	b = ftell(f)-1;
	e = b+1;
	do {
		C[c]--;
		check();
		c = space();
		e = ftell(f);
	} while (!feof(f));
	fclose(f);
	FILE *fo = fopen("output.txt", "w");
	fprintf(fo, "%lu\n", R);
	fclose(fo);
	return 0;
}