Type
  TPoint = record
    x,y:integer;
  end;

const
  infile = 'input.txt';
  outfile = 'output.txt';

var
  fi, fo : text;
  x,y,i,pc,xmin,xmax,ymin,ymax:integer;
  p:array [1..200] of TPoint;

procedure qsortx(l, r : integer);
var
  i, j : integer;
  x, w : TPoint;
begin
  i := l;
  j := r;
  x := p[(i+j)div 2];
  repeat
    while x.x > p[i].x do i := i +1;
    while x.x < p[j].x do j := j - 1;
    if (i <= j) then begin
      w := p[i]; p[i] := p[j]; p[j] := w;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if i < r then qsortx(i,r);
  if j > l then qsortx(l,j);
end;

procedure qsorty(l, r : integer);
var
  i, j : integer;
  x, w : TPoint;
begin
  i := l;
  j := r;
  x := p[(i+j)div 2];
  repeat
    while x.y > p[i].y do i := i +1;
    while x.y < p[j].y do j := j - 1;
    if (i <= j) then begin
      w := p[i]; p[i] := p[j]; p[j] := w;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if i < r then qsorty(i,r);
  if j > l then qsorty(l,j);
end;

procedure sort;
var
  i, from : integer;
begin
  qsortx(1, pc);
{  from := 1;
  for i := 2 to pc do begin
    if (p[i].x <> p[from].x) then begin
      if (i - from > 1) then begin
        qsorty(from, i-1);
      end;
      from := i;
    end;
  end;}
end;

function Exist(x,y:integer):boolean;
var
  i, j, k : integer;
  found : boolean;
begin
  i := 1; j := pc; found := false;
  while i <> j do begin
    k := (i+j) div 2;
    if (p[k].x < x) then i := k + 1 else j := k;
  end;
  if (p[i].x = x) then begin
    while (i <= pc) and (not found) and (p[i].x = x) do begin
      if p[i].y = y then found := true;
      i := i + 1;
    end;
  end;
  Exist := found;
end;

begin
  assign(fi, infile); assign(fo, outfile);
  reset(fi); rewrite(fo);
  readln(fi,pc);
  for i:=1 to pc do begin
    readln(fi,p[i].x,p[i].y);
  end;
  sort;
  xmin:=p[1].x;
  xmax:=p[1].x;
  ymin:=p[1].y;
  ymax:=p[1].y;
  for i:=2 to pc do begin
    if xmax<p[i].x then xmax:=p[i].x;
    if ymax<p[i].y then ymax:=p[i].y;
    if xmin>p[i].x then xmin:=p[i].x;
    if ymin>p[i].y then ymin:=p[i].y;
  end;

  if xmax<0 then xmax:=0;
  if ymax<0 then ymax:=0;
  if xmin>0 then xmin:=0;
  if ymin>0 then ymin:=0;

  for y:=ymax downto ymin do begin
    for x:=xmin to xmax do begin
      if Exist(x,y) then write(fo,'*') else
        if (x=0) and (y=0) then write(fo,'+') else
          if (x=0) then write(fo,'|') else
            if (y=0) then write(fo,'-') else
              write(fo,'.');
    end;
    writeln(fo);
  end;
  close(fi); close(fo);
end.