const
  infile = 'input.txt';
  outfile = 'output.txt';

var
  fi, fo : text;
  types : array [1..50] of string;
  ts, i, ct, error, n : integer;
  line : string;

procedure ReadData;
var
  i : integer;
begin
  readln(fi, n);
  readln(fi, line);
  ts := 0;
  for i := 2 to n do begin
    ts := ts + 1;
    readln(fi, types[ts]);
  end;
end;

function GetType : string;
begin
  case line[i] of
    'd' : GetType := 'int';
    'f','e','g','E','G' : GetType := 'single';
    'c' : GetType := 'char';
    's' : GetType := 'string';
    'l' : begin i := i + 1;
          case line[i] of
            'd' : GetType := 'longint';
            'f','e','g','E','G' : GetType := 'double';
          end;
          end;
    'L' : begin i := i + 1;
          case line[i] of
            'f','e','g','E','G' : GetType := 'extended';
          end;
          end;
  end;
  i := i + 1;
end;

procedure Process;
begin
  i := i + 1;
  if line[i] in ['-','+'] then i := i + 1;
  if (line[i] = '*') or (line[i] in ['0'..'9']) then begin
    if (line[i] = '*') then begin
      if ct > ts then begin
        error := 2; exit;
      end else begin
        if types[ct] <> 'int' then begin
          error := 1; exit;
        end else begin
          ct := ct + 1;
        end;
      end;
      i := i + 1;
    end;
    if (line[i] in ['0'..'9']) then begin
      while (line[i] in ['0'..'9']) do i := i + 1;
    end;
  end;
  if line[i] = '.' then begin
    i := i + 1;
    if (line[i] = '*') or (line[i] in ['0'..'9']) then begin
      if (line[i] = '*') then begin
        if ct > ts then begin
          error := 2; exit;
        end else begin
          if types[ct] <> 'int' then begin
            error := 1; exit;
          end else begin
            ct := ct + 1;
          end;
        end;
        i := i + 1;
      end;
      if (line[i] in ['0'..'9']) then begin
        while (line[i] in ['0'..'9']) do i := i + 1;
      end;
    end;
  end;
  if (gettype <> types[ct]) then begin
    error := 1; exit;
  end else ct := ct + 1;
end;

procedure Main;
begin
  i := 1; error := 0; ct := 1;
  while (i < length(line)) and (error = 0) do begin
    if line[i] = '%' then begin
      if line[i+1] <> '%' then begin
        Process;
      end else i := i + 2;
    end else begin
      i := i + 1;
    end;
  end;
  if (error = 0) and (ct <= ts) then error := 3;
  if error = 0 then begin
    writeln(fo, 'OK');
  end else begin
    writeln(fo, 'ERROR ', error);
  end;
end;

begin
  assign(fi, infile); assign(fo, outfile);
  reset(fi); rewrite(fo);
  ReadData;
  Main;
  close(fi); close(fo);
end.