#include <stdio.h>
#include <math.h>
#include <process.h>

const long double e=1e-8;

FILE *f,*f1;
long i,n,a,b,c,pr,k,j;
long double t;

void out(long k) {
	if (k<1000000000) fprintf(f1,"%ld\n",k);
	else fprintf(f1,"1000000000\n");
	return;
}

long podh(long k) {
	return (((long double)(k+1))*(k+1) > (t+e));
}

int main(){
	f=fopen("input.txt","r");
	f1=fopen("output.txt","w");
	fscanf(f,"%ld",&n);

for (i=0; i<n; i++) {
    fscanf(f,"%ld%ld%ld",&a,&b,&c);
    t=3/(long double)a/(long double)a*((long double)b*(long double)b-4*(long double)a*(long double)c)+1;
    if (podh(0)) {
	out(0);
	continue;
    }
    if (podh(1)) {
	out(1);
	continue;
    }
    k=ceil(sqrt(t))-1;
    pr=k-10;
    if (pr<0) pr=0;
    for (j=pr; j<=k+10; j++)
	if (podh(j)) {
		out(j);
		break;
	}
}

	fclose(f1);
	return 0;
}