TYPE
    TTYPES = array[1..1000] of integer;

VAR
   str    : string;
   tstr   : string;
   carg   : integer;
   aarg   : integer;
   atypes : TTYPES;
   itypes : TTYPES;
   ps     : integer;
   min    : integer;
   i      : integer;

FUNCTION StrToType(str : string) : integer;
         begin
              if str = 'int' then
                 StrToType := 1;
              if str = 'longint' then
                 StrToType := 2;
              if str = 'single' then
                 StrToType := 3;
              if str = 'double' then
                 StrToType := 4;
              if str = 'extended' then
                 StrToType := 5;
              if str = 'char' then
                 StrToType := 6;
              if str = 'string' then
                 StrToType := 7;
         end;

FUNCTION StrFormatToType(str : string) : integer;
         begin
              if str = 'd' then
                 StrFormatToType := 1;
              if str = 'ld' then
                 StrFormatToType := 2;
              if str = 'c' then
                 StrFormatToType := 6;
              if str = 's' then
                 StrFormatToType := 7;
              if (str = 'f') or (str = 'e') or (str = 'g') or (str = 'E')  or (str = 'G') then
                 StrFormatToType := 3;
              if (str = 'lf') or (str = 'le') or (str = 'lg') or (str = 'lE')  or (str = 'lG') then
                 StrFormatToType := 4;
              if (str = 'Lf') or (str = 'Le') or (str = 'Lg') or (str = 'LE')  or (str = 'LG') then
                 StrFormatToType := 5;
         end;

PROCEDURE PARSE;
          var
             typestr : string;
          begin
               while (ps <= Length(str)) and (str[ps] <> '%') do
                     Inc(ps);
               if ps <= Length(str) then
                  begin
                  Inc(ps);
                  if str[ps] <> '%' then
                     begin
                     typestr := '';
                     while not (str[ps] in ['d', 'l', 'f', 'e', 'g', 'E', 'G', 'L', 'c', 's']) do
                           begin
                           if str[ps] = '*' then
                              begin
                              Inc(aarg);
                              atypes[aarg] := 1;
                              end;
                           Inc(ps);
                           end;
                     typestr := typestr + str[ps];
                     if str[ps] in ['l', 'L'] then
                        begin
                        Inc(ps);
                        typestr := typestr + str[ps];
                        end;
                     Inc(ps);
                     Inc(aarg);
                     atypes[aarg] := StrFormatToType(typestr);
                     end
                  else
                      Inc(ps);
                  end;
          end;

BEGIN
     Assign(input, 'input.txt');
     ReSet(input);
     Assign(output, 'output.txt');
     ReWrite(output);

     ReadLN(carg);
     ReadLN(str);

     for i := 1 to carg - 1 do
         begin
         ReadLN(tstr);
         itypes[i] := StrToType(tstr);
         end;

     ps := 1;
     aarg := 0;
     while ps <= Length(str) do
           PARSE;

     min := aarg;
     if carg - 1 < aarg then
        min := carg - 1;

     i := 1;
     while (i <= min) and (atypes[i] = itypes[i]) do
           Inc(i);

     if (i > min) then
        begin
        if carg - 1 = aarg then
           WriteLN('OK')
        else
            if carg - 1 < aarg then
               WriteLN('ERROR 2')
            else
                WriteLN('ERROR 3');
        end
     else
         WriteLN('ERROR 1');

     Close(output);
     Close(input);
END.