{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
Program Hook;
const
     infinity = 1000;
var
   Res : Extended;
   XF,YF,XA,YA,x1,x2,x3,y1,y2,y3 : Extended;


Function sq(x1,y1,x2,y2,x3,y3 : Extended) : Extended;
Begin
     sq:=(x2-x1)*(y3-y1) - (x3-x1)*(y2-y1);
end;

Function FinTria(x1,y1,x2,y2,x3,y3 : Extended) : Boolean;
var
   c1,c2,c3 : Extended;
Begin
     c1:=sq(x1,y1,xf,yf,x2,y2);
     c2:=sq(x2,y2,xf,yf,x3,y3);
     c3:=sq(x3,y3,xf,yf,x1,y1);
     FinTria:= (c1>=0)and(c2>=0)and(c3>=0) or
               (c1<=0)and(c2<=0)and(c3<=0);

end;

Function OnLine(xx,yy,x1,y1,x2,y2 : Extended) : Boolean;
Begin
     OnLine:= abs((xx-x1)*(y2-y1) - (yy-y1)*(x2-x1))<1e-5
end;

Function Cross(x1,y1,x2,y2 : Extended) : Integer;
var
   s1,s2,s3,q1,q2,q3 : Extended;
Begin
     if OnLine(xA,yA,x1,y1,x2,y2) or
        OnLine(xF,yF,x1,y1,x2,y2) or
        OnLine(x1,y1,xA,yA,xF,yF) or
        OnLine(x2,y2,xA,yA,xF,yF) then
     begin
          Cross:=1;
          EXIT;
     end;
     s1:=sq(x1,y1,xA,yA,xF,yF);
     s2:=sq(x1,y1,xA,yA,x2,y2);
     s3:=sq(x1,y1,x2,y2,xF,yF);

     q1:=sq(x2,y2,xA,yA,xF,yF);
     q2:=sq(x2,y2,xA,yA,x1,y1);
     q3:=sq(x2,y2,x1,y1,xF,yF);
     if ( ((s1>=0)and(s2>=0)and(s3>=0)) or ((s1<=0)and(s2<=0)and(s3<=0))) and
        ( ((q1>=0)and(q2>=0)and(q3>=0)) or ((q1<=0)and(q2<=0)and(q3<=0))) then
        begin
              Cross:=1;
        end
        else Cross:=0;

end;

Function Cross2(x1,y1,x2,y2,x3,y3 : Extended) : Boolean;
var
   c : Integer;
Begin
     c:=Cross(x1,y1,x2,y2);
     c:=c+Cross(x2,y2,x3,y3);
     c:=c+Cross(x3,y3,x1,y1);
     Cross2:=c=2;
end;

Procedure Solve;
var
   i : Integer;
   t,xm,ym : Extended;
Begin
     X1:=10; y1:=0;
     X2:=0;  y2:=0;
     x3:=10; y3:=10;
     for i:=1 to infinity do
     begin
          xm:=(x2+x3)/2; ym:=(y2+y3)/2;
          If Cross2(xm,ym,x1,y1,x2,y2) then
             Res:=Res + Abs(sq(xm,ym,x1,y1,x2,y2)/2);
          If Cross2(xm,ym,x1,y1,x3,y3) then
             Res:=Res + Abs(sq(xm,ym,x1,y1,x2,y2)/2);
          If FinTria(x1,y1,xm,ym,x2,y2) then
          begin
               x3:=x1; y3:=y1;
               x1:=xm; y1:=ym;
          end
          else
          begin
               x2:=x1; y2:=y1;
               x1:=xm; y1:=ym;
          end;
          if x3>x2 then
          begin
               t:=x3; x3:=x2; x2:=t;
               t:=y3; y3:=y2; y2:=t;
          end;
          if (x3=x2) and (y3>y2) then
          begin
               t:=x3; x3:=x2; x2:=t;
               t:=y3; y3:=y2; y2:=t;
          end;
     end;
end;

Begin
     Assign(input,'input.txt');
     Reset(input);
     Readln(XF,YF);
     XA:=0; YA:=0;
     Close(input);
     Solve;

     Assign(output,'output.txt');
     Rewrite(output);
     Writeln(Res:0:3);
     CLose(output);
end.