Const
  MaxN=100;
Type
  TMas=Record
    X,Y:LongInt;
  end;
var
  input,output:text;
  X,Y,R,N:LongInt;
  C:array[1..MaxN]of TMas;
  MinX,MaxY, MaxX,MinY:LongInt;

  Function Cmp(A,B:TMas):Boolean;
  begin
    If A.Y>B.Y then Cmp:=True else
    If A.Y<B.Y then Cmp:=False else
    If A.Y=B.Y then
    begin
      If A.X<B.X then Cmp:=True else
      If A.X=B.X then Cmp:=False else
      If A.X>B.X then Cmp:=False;
    end;
  end;

  Procedure QSort(l,r:LongInt);
  Var
    t:TMas;
    i,j:LongInt;
    m:TMas;
  begin
    i:=l; j:=r;
    t:=C[(r-l) div 2+l];
    repeat
      while {C[I]<t} Cmp(C[i],t) do inc(I);
      while {t<C[i]} Cmp(t,C[j]) do dec(J);
      If i<=j then
      begin
        m:=c[i];
        c[i]:=c[j];
        c[j]:=m;
        inc(i);
        dec(j);
      end;
    until i>=j;
    if i<r then QSort(i,r);
    if j>l then QSort(l,j);
  end;

begin
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(Input);
  rewrite(Output);
  {}
  Readln(Input,N);
  MinX:=0;
  MinY:=0;
  MaxX:=0;
  MaxY:=0;
  For R:=1 to N do
  begin
    Readln(Input,C[R].X,C[R].Y);
    If C[R].X>MaxX then MaxX:=C[R].X;
    If C[R].X<MinX then MinX:=C[R].X;
    If C[R].Y>MaxY then MaxY:=C[R].Y;
    If C[R].Y<MinY then MinY:=C[R].Y;
  end;
  QSort(1,N);
  R:=1;
  For Y:=MaxY downto MinY do
  begin
    For X:=MinX to MaxX do
    begin
      If (C[R].X=X)and(C[R].Y=Y)and(R<=N) then
      begin
        Write(Output,'*');
        Inc(R);
      end else
      begin
        If (X=0)and(Y=0) then Write(Output,'+') else
        If (X=0) then Write(Output,'|') else
        If (Y=0) then Write(Output,'-') else
        Write(Output,'.');
      end;
    end;
    Writeln(Output);
  end;
  {}
  close(Input);
  close(Output);
end.