#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

typedef unsigned long ulong;
typedef unsigned int uint;

#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

int N, L=0;
char S[202];

FILE *fi;

int par(char *s) {
	char S2[80];
	fscanf(fi, "%s\n", S2);
	N--;
	return !strcmp(s, S2);
}

int check(char *s) {
	if ((*s=='d' && !par("int")) ||
	    (*s=='l' && s[1]=='d' && !par("longint"))||
	    (strchr("fegEG", *s) && !par("single"))||
	    (*s=='l' && strchr("fegEG", s[1]) && !par("double")) ||
	    (*s=='L' && strchr("fegEG", s[1]) && !par("extended")) ||
	    (*s=='c' && !par("char")) ||
	    (*s=='s' && !par("string")))
		return '1';
	return 0;
}

int main() {
	fi = fopen("input.txt", "r");
	fscanf(fi, "%d\n", &N);
	N--;
	do {
		char c = fgetc(fi);
		if (c=='\n') break;
		S[L++] = c;
	} while (1);
	char s = 0;
	char *p = S;
	do {
		switch (s) {
			case 0 : if (*p=='%') {
					if (p[1]=='%') p++;
					else s = 1;
				 }
				 break;
			case 1 : if (*p=='*') {
					if (!par("int")) s = '1';
					break;
				}
				if (strchr("dfegEGlLcs", *p)) {
					s = 2;
					p--;
				}
				break;
			case 2: s = check(p); break;
		}
		p++;
	} while (s<'0' && *p);
	fclose(fi);
	FILE *fo = fopen("output.txt", "w");
	if (s=='1') {
		if (N>=0) fprintf(fo, "ERROR 1");
		else fprintf(fo, "ERROR 2");
	} else {
		if (N==0) fprintf(fo, "OK");
		else fprintf(fo, "ERROR 3");
	}
	fclose(fo);
	return 0;
}